#include "Python.h"
#include "Simil.h"

static PyObject *
simil_Check (PyObject * pSelf, PyObject * pArgs)
{
	char *s1, *s2;

	if (!PyArg_ParseTuple (pArgs, "ss:Check", &s1, &s2))
		return NULL;

	return Py_BuildValue ("f", strings_check (s1, s2));
}

static PyObject *
simil_Levenshtein (PyObject * pSelf, PyObject * pArgs)
{
	char *s1, *s2;

	if (!PyArg_ParseTuple (pArgs, "ss:Levenshtein", &s1, &s2))
		return NULL;

	return Py_BuildValue ("f", pre_LD (s1, s2));
}

static PyObject *
simil_Ratcliff (PyObject * self, PyObject * pArgs)
{
	char *s1, *s2;

	if (!PyArg_ParseTuple (pArgs, "ss:Ratcliff", &s1, &s2))
		return NULL;

	return Py_BuildValue ("f", ratcliff (s1, s2));
}

static PyObject *
simil_Ratcliff2 (PyObject * self, PyObject * pArgs)
{
	char *s1, *s2;

	if (!PyArg_ParseTuple (pArgs, "ss:Ratcliff2", &s1, &s2))
		return NULL;

	return Py_BuildValue ("f", ratcliff2 (s1, s2));
}

static PyMethodDef simil_methods[] = {
	{"Check", simil_Check, METH_VARARGS,
	 "Preliminary strings check"},
	{"Levenshtein", simil_Levenshtein, METH_VARARGS,
	 "Levenshtein Distance similarity"},
	{"Ratcliff", simil_Ratcliff, METH_VARARGS,
	 "Ratcliff-Obershelp common-subpattern similarity"},
	{"Ratcliff2", simil_Ratcliff2, METH_VARARGS,
	 "Ratcliff-Obershelp common-subpattern similarity v2"},
	{NULL, NULL}
};

void
initsimil (void)
{
	Py_InitModule ("simil", simil_methods);
}
