#!/usr/bin/env python

# Hello, this script is written in Python - http://www.python.org
# 2003 Luca Montecchiani <cbm64@inwind.it>
#
# TODO:
#
# - improve speed
# - wrote some docs
# - add/improve simil module (fuzzy ?!?)
# - make string treshold a parameter
# - include md5,and other search method
# - wrote a nice obj interface
# - wrote a nice gui interface with wxPython

import os, os.path, string, sys, difflib 
import simil

# global vars
estenzioni = ( "tar","gz","tgz","bz2","txt","pdf","html","htm","zip","doc" , "ps", "ppt", "xls", "rpm" )
amethod = ( "none","int","lev","rat","rat2" )
level = 0.8
scartati = 0
VER = 0.7

def fattoriale(n):
    "FIXME write documentation here !"
    if n == 1:
        return 1
    else:
        return n * fattoriale(n-1)

def Compare(a,b,cmethod):
    "FIXME write documentation here !"
    if cmethod == "none":
        return 0
    if cmethod == "int":
	c = simil.Check(a,b)
        if c == 2.0:
            c = difflib.SequenceMatcher(None,a,b).ratio()
        return ( c > level )
    if cmethod == "lev":
        return ( simil.Levenshtein(a,b) > level )
    if cmethod == "rat":
        return  ( simil.Ratcliff(a,b) > level )
    if cmethod == "rat2":
        return  ( simil.Ratcliff2(a,b) > level )
    print cmethod + " not done yet ;) "
    sys.exit(1)

def detectSameName( cmethod, directories ):
    "FIXME write documentation here !"
    global scartati
    fileslist = []
    scartati = 0
    # Group all files by size (in the fileslist dictionnary)
    for directory in directories.split(','):
        directory = os.path.abspath(directory)
        sys.stderr.write('Scanning directory:'+directory+' ')
        os.path.walk(directory,callbackName,fileslist)
        sys.stderr.write('\n')

    # how many iterations ?
    k = 2
    n = len(fileslist)
    t = n * ( n - k + 1 )
    for h in range(1,k-1):
        t = t * ( n - h )
    c = t / fattoriale(k)

    sys.stderr.write("Files scanned     : %d\n" % n)
    sys.stderr.write("Files discarded   : %d\n" % scartati)
    sys.stderr.write("Max iterations    : %d\n" % c)
    sys.stderr.write("Compare method    : %s\n" % cmethod)
    sys.stderr.write("Compare level     : %f\n" % level)

    filesfound = {}

    sys.stderr.write('Comparing files name...\n')

    for x in fileslist:
        for y in fileslist[fileslist.index(x)+1:]:
            if Compare(x[0],y[0],cmethod):
                if filesfound.has_key(x[1]):
                    filesfound[x[1]].append(y[1])
                else:
                    filesfound[x[1]] = [y[1]]
                # remove the found element for the next iterations
                del fileslist[fileslist.index(y)]
#            c = c - 1
#            print "%d \r" % ( c ),

    print "\n"
    return filesfound

def callbackName(fileslist,directory,files):
    "FIXME write documentation here !"
    global scartati
#    sys.stderr.write(".")
    for fileName in files:
        filepath = os.path.join(directory,fileName)
        if os.path.isfile(filepath) and len(fileName) > 4:
            # Lowercase it
            newName = fileName.lower()
	    mp3 = newName.find(".mp3")
            # tolgo le estenzioni conosciute o l'estenzione stessa
            for e in estenzioni:
                newName =  newName.replace("."+e,"")
            # MP3 specific :))
	    if mp3 > 0:
                # remove all digits !
                for e in string.digits:
        	    newName = newName.replace(e,"")
                # replace _ with blank
        	newName = newName.replace("_"," ")
                # Artist - album - NN Title.mp3 -> title
        	if newName.find("-") > 0 :
        	    newName = newName.split("-")[-1]
            # strip left and right
	    newName = newName.lstrip()
	    newName = newName.rstrip()

            # inserisco solo i nomi > 3
            if len(newName) > 3:
                fileslist.append([newName,filepath])
	    else:
	        scartati += 1

def Errore():
    "FIXME write documentation here !"
    print "\nUse: fdupes.py mode directory1,directory2,directoryN"
    print "          mode can be: "
    print amethod
    sys.exit(1)

#######################################
# Main
#######################################

# controllo argomenti
if len(sys.argv) < 3 or ( sys.argv[1] != "all" and sys.argv[1] in amethod == 0 ) :
    Errore()

cmethod = sys.argv[1]
direttori = " ".join(sys.argv[2:])

doubles = detectSameName(cmethod,direttori)
print 'The following files are similar:\n'
for doubleK in doubles.keys():
    print doubleK
    for doubleV in doubles[doubleK]:
        print doubleV
    print '----'
